""" Piplines class contains methods that return pipline operators for the mongo aggregation method

:Author: Bilal Shaikh < bilalshaikh42@gmail.com >
:Date: 2020-02-29
:Copyright: 2020, Karr Lab
:License: MIT
"""


class Pipelines():

    @staticmethod
    def get_public():
        return [{"$match": {"$or": [{"private": False}, {"private": None}]}}]

    @staticmethod
    def get_private_by_owner(owner_id):
        return [{"$match": {"private": True, "owner": owner_id}}]

    @staticmethod
    def convert_object_id_to_id():
        return [{"$addFields": {"id": {"$toString": "$_id"}}}, {"$project": {"_id": 0, }}]

    @staticmethod
    def convert_owner_id_to_username(user_collection="users"):
        return [{"$lookup": {"from": user_collection, "localField": "owner",
                             "foreignField": "_id", "as": "owner"}},
                {"$unwind": "$owner"},
                {"$addFields": {"owner": "$owner.userName"}}]

    @staticmethod
    def match_file_id(id):
        return [{"$match": {"_id": id}}]
